
package de.ivu.elect.presentation.staat;

import javax.annotation.PostConstruct;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.staat.boundary.StaatBoundaryCreate;
import de.ivu.elect.business.staat.boundary.StaatFactory;
import de.ivu.elect.business.staat.entity.Staat;
import de.ivu.elect.business.staat.entity.StaatMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractStaatCreateNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractStaatCreateNoScopeView.VIEW_ID, useCase = UseCasePermission.STAAT_CREATE)
public abstract class AbstractStaatCreateNoScopeView extends de.ivu.elect.presentation.AbstractElectCreateView<Staat> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "staatCreateView";

  public static final String VIEW_ID = "/staat/staat-create.xhtml";

  public static final String PARENT_VIEW_ID = "/staat/staat-search.xhtml";

  @Inject
  protected transient StaatBoundaryCreate create;

  protected Staat entity;

  @Inject
  protected transient StaatMeta entityMeta;

  
  @Inject
  protected transient StaatFactory factory;

  public AbstractStaatCreateNoScopeView() {
    super();
  }

  @PostConstruct
  public void init() {
    setEntity(factory.create());
  }

  

  public Staat getEntity() {
    return entity;
  }

  protected void setEntity(Staat entity) {
    this.entity = entity;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.STAAT_CREATE)
  public String save() {
    callSave(getEntity());

    addMessageSaveSuccess(getEntity());

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(Staat entity) {
    create.save(entity);
  }

  protected void addMessageSaveSuccess(Staat entity) {
    addInfoMessage("entity.create.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnSaveRendered() {
    return hasPermission(UseCasePermission.STAAT_CREATE);
  }

  @Redirect
  public String reset() {
    resetStateAfterAction();

    init();

    return getViewId();
  }

  public boolean isBtnResetRendered() {
    return true;
  }

  @Redirect
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  public boolean isBtnCancelRendered() {
    return true;
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    // Do nothing.
  }
}
